﻿//////////////////////////////////////////////////
//               ArcherSettings.cs              //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.ComponentModel;
using System.Configuration;

namespace RebornCo.Settings
{
    public class ArcherSetting : CoreSetting
    {
        public ArcherSetting(string filename = "RebornCoSettingsArcher")
            : base(filename)
        {
        }

        [Setting]
        [DefaultValue(false)]
        [Category("Archer")]
        public bool WaitEnergyPull { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Bard")]
        public bool MagesBallad { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Bard")]
        public bool FoeRequiem { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Bard")]
        public bool ArmysPaeon { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Bard")]
        public bool BattleVoice { get; set; }

        [Setting]
        [DefaultValue(3)]
        [Category("Bard")]
        public int SongHpCount { get; set; }

        [Setting]
        [DefaultValue(3)]
        [Category("Bard")]
        public int SongTpCount { get; set; }

        [Setting]
        [DefaultValue(3)]
        [Category("Bard")]
        public int SongManaCount { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("Bard")]
        public float ManaForSongs { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("Bard")]
        public float SongHpPercent { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("Bard")]
        public float SongTpPercent { get; set; }

        [Setting]
        [DefaultValue(40f)]
        [Category("Bard")]
        public float SongManaPercent { get; set; }

        [Setting]
        [DefaultValue(3000)]
        [Category("Archer")]
        public int VenomousClip { get; set; }

        [Setting]
        [DefaultValue(3000)]
        [Category("Archer")]
        public int WindbiteClip { get; set; }

    }

}