﻿//////////////////////////////////////////////////
//              MaruaderSettings.cs             //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.ComponentModel;
using System.Configuration;

namespace RebornCo.Settings
{
    public class MarauderSetting : CoreSetting
    {
        public MarauderSetting(string filename = "RebornCoSettingsMaruader")
            : base(filename)
        {
        }

        [Setting]
        [DefaultValue(false)]
        [Category("Maruader")]
        public bool OpenWithExtraSs { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Maruader")]
        public bool OpenerUse { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Maruader")]
        public bool OpenerPartyOnly { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Tank")]
        public bool BuffedTomahawk { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Maruader")]
        public bool BrutalSwing { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Maruader")]
        public bool Fracture { get; set; }

        [Setting]
        [DefaultValue(1000)]
        [Category("Maruader")]
        public int MaimClip { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Maruader")]
        public bool MaimKeepActive { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Maruader")]
        public bool PreventBackToBackEyeAndPath { get; set; }

        [Setting]
        [DefaultValue(4000)]
        [Category("Maruader")]
        public int StormsEyeClip { get; set; }

        [Setting, DefaultValue(System.Windows.Input.Key.V)]
        [Category("Maruader")]
        public System.Windows.Input.Key StormsEyeHotKeyChoice { get; set; }

        [Setting, DefaultValue(ModifierKey.Shift)]
        [Category("Maruader")]
        public ModifierKey StormsEyeModKeyChoice { get; set; }

        [Browsable(false)]
        public System.Windows.Input.Key LastStormsEyeHotKeyChoice { get; set; }
        [Browsable(false)]
        public ModifierKey LastStormsEyeModKeyChoice { get; set; }

        [Setting]
        [DefaultValue(4000)]
        [Category("Maruader")]
        public int StormsPathClip { get; set; }

        [Setting, DefaultValue(System.Windows.Input.Key.B)]
        [Category("Maruader")]
        public System.Windows.Input.Key StormsPathHotKeyChoice { get; set; }

        [Setting, DefaultValue(ModifierKey.Shift)]
        [Category("Maruader")]
        public ModifierKey StormsPathModKeyChoice { get; set; }

        [Browsable(false)]
        public System.Windows.Input.Key LastStormsPathHotKeyChoice { get; set; }
        [Browsable(false)]
        public ModifierKey LastStormsPathModKeyChoice { get; set; }

    }

}