﻿//////////////////////////////////////////////////
//                RogueSettings.cs              //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.ComponentModel;
using System.Configuration;

namespace RebornCo.Settings
{
    public class RogueSetting : CoreSetting
    {
        public RogueSetting(string filename = "RebornCoSettingsRogue")
            : base(filename)
        {
        }

        [Setting]
        [DefaultValue(true)]
        [Category("Rogue")]
        public bool SneakAttack { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Rogue")]
        public bool WaitEnergyPull { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Rogue")]
        public bool UseHide { get; set; }

        [Setting]
        [DefaultValue(6000)]
        [Category("Ninja")]
        public int HutonClip { get; set; }

        [Setting]
        [DefaultValue(false)]
        [Category("Ninja")]
        public bool MoveStopNinjutsu { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Ninja")]
        public bool IgnoreMudraDoAction { get; set; }

        [Setting]
        [DefaultValue(15f)]
        [Category("Ninja")]
        public float MinNinjutsu { get; set; }

        [Setting]
        [DefaultValue(8000)]
        [Category("Rogue")]
        public int DancingEdgeClip { get; set; }

        [Setting]
        [DefaultValue(7000)]
        [Category("Rogue")]
        public int ShadowFangClip { get; set; }

        [Setting]
        [DefaultValue(6000)]
        [Category("Rogue")]
        public int MutilationClip { get; set; }

        [Setting]
        [DefaultValue(1600)]
        [Category("Ninja")]
        public double NinjutsuWindowStart { get; set; }
    }

}